program ResMeter;

{	  -    	}
{	 Windows      	}
{	.    BP 7.0 for Windows   Delphi 1 .	}
{	       	}
{	 ,     	}
{	      Win 3.1x .              }
{          /r     ,          }
{         /e       .         }
{              .           }
{             win.ini              }
{       ,               }
{           .                                       }
{		      Copyright () ALEX Software, 1998			}
{                                                      }

{$R About}
{$C Moveable Discardable}

uses WinTypes, WinProcs, Messages, Stress;

type TLanguage=(Russian,English);

const
  AppName = 'ResMeter';
  idMenu=10;
  idAbout=11;
  Copyright='Copyright ALEX Software, 1998.';
  Name=' .';
  ecUser='User: %d %% free.';
  ecGdi='Gdi: %d %% free.';
  ecMem='Memory: %lu bytes free.';
  rcUser='User: %d %% .';
  rcGdi='Gdi: %d %% .';
  rcMem=': %lu  .';
var
  Window: HWnd;
  DC:HDC;
  Brush:HBrush;
  SysMenu:HMenu;
  Language:TLanguage;
  Width:byte;
  pOut:PChar;
  Entry:byte;
  XPos:word;
  YPos:word;
  User:word;{Free USER resources, ready for output}
  GDI:word;{Free GDI resources, ready for output}
  Memory:longint;{Free memory, in KBytes, ready for output}
  cUser,cGdi,cMem:PChar;
  Buffer:PChar;


function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, 2);
  GetMem(Result, Size);
  Word(Pointer(Result)^) := Size;
  Inc(Result, 2);
end;

procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, 2);
    FreeMem(Str, Word(Pointer(Str)^));
  end;
end;

procedure Load(id:word);
begin
Buffer:=StrAlloc(255);
LoadString(hInstance,id,buffer,255);
end;

procedure ShowInfo;
var _Len:byte;
begin
pOut:=StrAlloc(64);
case Language of
     Russian:
             begin
             _Len:=wvsprintf(pOut,rcUser,User);
             TextOut(Dc,2,1,pOut,_Len);
             _Len:=wvsprintf(pOut,rcGdi,Gdi);
             TextOut(Dc,2,17*1,pOut,_Len);
             _Len:=wvsprintf(pOut,rcMem,Memory);
             TextOut(Dc,2,17*2,pOut,_Len);
             end;
     English:
             begin
             _Len:=wvsprintf(pOut,ecUser,User);
             TextOut(Dc,2,1,pOut,_Len);
             _Len:=wvsprintf(pOut,ecGdi,Gdi);
             TextOut(Dc,2,17*1,pOut,_Len);
             _Len:=wvsprintf(pOut,ecMem,Memory);
             TextOut(Dc,2,17*2,pOut,_Len);
             end;
end;
StrDispose(pOut);
end;

procedure Digest(Dialog:HWnd);
var
   pS:PChar;
begin
pS:=StrAlloc(64);
SetDlgItemText(Dialog,1000,PChar(Copyright));
SetDlgItemText(Dialog,200,PChar(Name));
if GetDlgItemText(Dialog,200,pS,64)=0 then Halt(1);
if GetDlgItemText(Dialog,1000,pS,64)=0 then Halt(1);
StrDispose(pS);
end;

function _About(Dialog:HWnd;AMessage,wParam:word;lParam:longint):boolean;export;
begin
Result:=True;
case AMessage of
     wm_initdialog:begin Digest(Dialog);Exit;end;
     wm_command:if wParam=102 then begin EndDialog(Dialog,1);Exit;end;
end;
Result:=False;
end;

procedure About;
var
   AboutProc:TFarProc;
begin
AboutProc:=MakeProcInstance(@_About,hInstance);
DialogBox(hInstance,PChar('ABOUT'),Window,AboutProc);
FreeProcInstance(AboutProc);
end;

procedure Alert;
begin
try
KillTimer(Window,8);
Load(1);
if MessageBox(Window,Buffer,AppName,mb_OkCancel)=idOk then FreeAllGdiMem;
Entry:=0;
finally
SetTimer(Window,8,100, nil);
StrDispose(Buffer);
end;
end;

procedure Starting;
begin
DC:=GetDc(Window);
SetBkColor(Dc,$C0C0C0);
SysMenu:=GetSystemMenu(Window,False);
AllocGdiMem((GetFreeSystemResources(1)*65536 div 100)-4048 );
About;
AppendMenu(SysMenu,mf_separator,100,nil);
AppendMenu(SysMenu,mf_String+mf_Enabled,IdMenu,PChar('&'));
AppendMenu(SysMenu,mf_String+mf_Enabled,IdAbout,PChar('&About'));
if (ParamStr(1)='/r') or (ParamStr(1)='/R') or
(GetProfileInt(AppName,'Language',0)=1) then
    begin
    Language:=Russian;
    CheckMenuItem(SysMenu,idMenu,mf_checked);
    end
else
    begin
    Language:=English;
    CheckMenuItem(SysMenu,idMenu,mf_unchecked);
    end;
if Language=Russian then Width:=8 else Width:=7;
SetWindowPos(Window,hwnd_topmost,0,0,Width*29,18*4,swp_showwindow+swp_nomove);
Entry:=15;
SetTimer(Window,8,100, nil);
end;


procedure Finalization;
{                Delphi 2 & 3,         }
var
   Out:PChar;
   Rect:TRect;
   Lang:word;
const
   Mask='%d';
begin
{             ~~~~     ~~~~   }
KillTimer(Window,8);
FreeAllGdiMem;
DeleteObject(Brush);
{             ~~~~   win.ini~~~~                       }
GetWindowRect(Window,Rect);
Out:=StrALloc(4);
wvsprintf(Out,Mask,Rect.Left);
WriteProfileString(AppName,'XPos',Out);
wvsprintf(Out,Mask,Rect.Top);
WriteProfileString(AppName,'YPos',Out);
if Language=Russian then Lang:=1 else Lang:=0;
wvsprintf(Out,Mask,Lang);
WriteProfileString(AppName,'Language',Out);
StrDispose(Out);
end;

function WindowProc(Window: HWnd; Message, WParam: Word;
  LParam: Longint): Longint; export;
begin
  WindowProc := 0;
  case Message of
    wm_Destroy:
      begin
        Finalization;
        PostQuitMessage(0);
        Exit;
      end;
    wm_close:
      begin
        SendMessage(Window,wm_destroy,0,0);
      end;
    wm_timer:
      begin
        User:=GetFreeSystemResources(2);{User resources}
        Gdi:=GetFreeSystemResources(1); {GDI resources}
        Memory:=GetFreeSpace(0);        {Free Memory }
        ShowInfo;
        if GetFreeSystemResources(1)<Entry then Alert;
        if GetFreeSystemResources(1)<40 then  SetTextColor(Dc,$0000FF)
        else SetTextColor(Dc,$000000);
      end;
    wm_syscommand:
        begin
        if wParam=idMenu then
           if GetMenuState(SysMenu,idMenu,mf_bycommand)=mf_unchecked then
              begin
              CheckMenuItem(SysMenu,idMenu,mf_checked);
              Language:=Russian;
              Width:=8;
              SetWindowPos(Window,hwnd_topmost,0,0,
              Width*29,18*4,swp_showwindow+swp_nomove);
              SendMessage(Window,wm_erasebkgnd,DC,0);
              end
           else
               begin
               CheckMenuItem(SysMenu,idMenu,mf_unchecked);
               Language:=English;
               Width:=7;
               SetWindowPos(Window,hwnd_topmost,0,0,
               Width*29,18*4,swp_showwindow+swp_nomove);
               SendMessage(Window,wm_erasebkgnd,DC,0);
               end;
           if wParam=idAbout then About;
        end;
  end;
  WindowProc := DefWindowProc(Window, Message, WParam, LParam);
end;

procedure WinMain;
var
  Message: TMsg;
const
  WindowClass: TWndClass = (
    style: 0;
    lpfnWndProc: @WindowProc;
    cbClsExtra: 0;
    cbWndExtra: 0;
    hInstance: 0;
    hIcon: 0;
    hCursor: 0;
    hbrBackground: 0;
    lpszMenuName: AppName;
    lpszClassName: AppName);
begin
  if HPrevInst = 0 then
  begin
    Brush:=CreateSolidBrush($C0C0C0);
    WindowClass.hInstance := HInstance;
    WindowClass.hIcon := LoadIcon(0, idi_Application);
    WindowClass.hCursor := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground := Brush;
    if not RegisterClass(WindowClass) then Halt(255);
  end
  else
  begin
  MessageBox(Window,'Resource Meter  ',AppName,0);
  Halt(255);
  end;
  XPos:=GetProfileInt(AppName,'XPos',10);
  YPos:=GetProfileInt(AppName,'YPos',10);
  Window := CreateWindow(
    AppName,
    'Resource Meter',
    Ws_sysmenu or Hwnd_Topmost or ws_MinimizeBox,
    XPos,
    YPos,
    8*30,
    18*4,
    0,
    0,
    HInstance,
    nil);
  Starting;
  ShowWindow(Window, CmdShow);
  UpdateWindow(Window);
  while GetMessage(Message, 0, 0, 0) do
  begin
    TranslateMessage(Message);
    DispatchMessage(Message);
  end;
  Halt(Message.wParam);
end;

begin
  WinMain;
end.
